import random

class Color:
  "Represents an RGB-color. This can be seen as a single point in the RGB-color space (http://en.wikipedia.org/wiki/RGB_color_space)"
  
  def __init__(self,r=-1,g=-1,b=-1):
    self.r =  (r,random.randrange(0,255))[r==-1]
    self.g = (g,random.randrange(0,255))[g==-1]
    self.b = (b,random.randrange(0,255))[b==-1]
  
  def distance_to(self,to):
    distance_r = (to.r-self.r)**2
    distance_g = (to.g-self.g)**2
    distance_b = (to.b-self.b)**2
    return (distance_r + distance_g + distance_b )**0.5
    
  def mean(self,to):
    r,g,b=(self.r+to.r)/2 , (self.g+to.g)/2, (self.b+to.b)/2
    return Color(r,g,b)
  
  def abberate(self):
    self.r = (self.r - random.randrange(-15,15)) % 255
    self.g = (self.g - random.randrange(-20,20)) % 255
    self.b = (self.b - random.randrange(-20,20)) % 255
    
  def tupel(self):
    return (self.r,self.g,self.b)
    
#~ first = Color()
#~ second = Color()
#~ print first.tupel()
#~ print second.tupel()
#~ print first.distance_to(second)
#~ print second.distance_to(first)
#~ print first.distance_to(second) == second.distance_to(first)
#~ print first.mean(second).tupel()
#~ print second.mean(first).tupel()
#~ print first.mean(second).distance_to(second.mean(first))